Index: django/template/loaders/database/__init__.py
===================================================================
--- django/template/loaders/database/__init__.py	(Revision 0)
+++ django/template/loaders/database/__init__.py	(Revision 0)
@@ -0,0 +1,25 @@
+# Wrapper for loading templates from the database.
+
+from django.template import TemplateDoesNotExist
+from django.contrib.sites.models import Site
+from django.conf import settings
+from django.template.models import Template
+
+try:
+    site = Site.objects.get_current()
+except:
+    site = None
+
+def load_template_source(template_name, template_dirs=None):
+    """
+    Loads templates from the database by querying the database field ``name``
+    with a template path and ``sites`` with the current site.
+    """
+    if site is not None:
+        try:
+            t = Template.objects.get(name__exact=template_name, sites__pk=site.id)
+            return (t.content, 'db:%s:%s' % (settings.DATABASE_ENGINE, template_name))
+        except:
+            pass
+    raise TemplateDoesNotExist, template_name
+load_template_source.is_usable = True
Index: django/template/loaders/database/models.py
===================================================================
--- django/template/loaders/database/models.py	(Revision 0)
+++ django/template/loaders/database/models.py	(Revision 0)
@@ -0,0 +1,28 @@
+from django.db import models
+from django.core import validators
+from django.contrib.sites.models import Site
+from django.utils.translation import gettext_lazy as _
+
+class Template(models.Model):
+    """
+    Defines a template model for use with the database template loader.
+    The field ``name`` is the equivalent to the filename of a static template.
+    """
+    name = models.CharField(_('name'), unique=True, maxlength=100, help_text=_("Example: 'flatpages/default.html'"))
+    content = models.TextField(_('content'))
+    sites = models.ManyToManyField(Site)
+    creation_date = models.DateTimeField(_('creation date'), auto_now_add=True)
+    last_changed = models.DateTimeField(_('last changed'), auto_now=True)
+    class Meta:
+        db_table = 'django_template'
+        verbose_name = _('template')
+        verbose_name_plural = _('templates')
+        ordering = ('name',)
+    class Admin:
+        fields = ((None, {'fields': ('name', 'content', 'sites')}),)
+        list_display = ('name', 'creation_date', 'last_changed')
+        list_filter = ('sites',)
+        search_fields = ('name','content')
+
+    def __str__(self):
+        return self.name
Index: docs/templates_python.txt
===================================================================
--- docs/templates_python.txt	(Revision 4563)
+++ docs/templates_python.txt	(Arbeitskopie)
@@ -538,6 +538,41 @@
     Just like ``app_directories`` above, but it loads templates from Python
     eggs rather than from the filesystem.
 
+``django.template.loaders.database.load_template_source``
+    Loads templates from the database and is represented by a standard Django
+    model living in `django/template/models.py`_.
+    
+    Installation:
+    
+    1. Put ``'django.template.loaders.database'``,  ``'django.contrib.admin'``
+       and ``'django.contrib.sites'`` in your ``INSTALLED_APPS`` setting.
+    2. Add ``'django.template.loaders.database.load_template_source' to 
+        ``TEMPLATE_LOADERS``
+    2. Run the command ``manage.py syncdb``.
+        
+    .. _INSTALLED_APPS: ../settings/#installed-apps
+    .. _TEMPLATE_LOADERS: ../settings/#template-loaders
+    
+    ``manage.py syncdb`` creates two tables in your database:
+    ``django_template`` and ``django_template_sites``. ``django_template`` is
+    a simple lookup table that maps a template name to the text content of the
+    template. The template name is the equivalent to the filename in the
+    filesystem template loader. ``django_template_sites`` associates a
+    template with a site.
+    
+    Templates are loaded by querying the database field ``name`` with a
+    template path as if they were static files. A template with the name
+    ``foo.html`` can be loaded with ``get_template('foo.html')``.
+    
+    You can find a new "Template" section on the admin index page. Edit
+    templates as you edit any other object in the system.
+
+    You can access template database objects via the `Django database API`_.
+
+    .. _Django model: ../model_api/
+    .. _django/template/loaders/database/models.py: http://code.djangoproject.com/browser/django/trunk/django/template/loaders/database/models.py
+    .. _Django database API: ../db_api/
+
 Django uses the template loaders in order according to the ``TEMPLATE_LOADERS``
 setting. It uses each loader until a loader finds a match.
 